diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/yans-error-rate-model.cc ns-3.34/src/wifi/model/yans-error-rate-model.cc
--- ns-3.33/src/wifi/model/yans-error-rate-model.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/yans-error-rate-model.cc	2021-07-14 10:31:07.000000000 -0700
@@ -179,15 +179,24 @@
 }
 
 double
-YansErrorRateModel::DoGetChunkSuccessRate (WifiMode mode, WifiTxVector txVector, double snr, uint64_t nbits) const
+YansErrorRateModel::DoGetChunkSuccessRate (WifiMode mode, const WifiTxVector& txVector, double snr, uint64_t nbits, uint8_t numRxAntennas, WifiPpduField field, uint16_t staId) const
 {
-  NS_LOG_FUNCTION (this << mode << txVector.GetMode () << snr << nbits);
+  NS_LOG_FUNCTION (this << mode << txVector << snr << nbits << +numRxAntennas << field << staId);
   if (mode.GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM
       || mode.GetModulationClass () == WIFI_MOD_CLASS_OFDM
       || mode.GetModulationClass () == WIFI_MOD_CLASS_HT
       || mode.GetModulationClass () == WIFI_MOD_CLASS_VHT
       || mode.GetModulationClass () == WIFI_MOD_CLASS_HE)
     {
+      uint64_t phyRate;
+      if ((txVector.IsMu () && (staId == SU_STA_ID)) || (mode != txVector.GetMode ()))
+        {
+          phyRate = mode.GetPhyRate (txVector.GetChannelWidth () >= 40 ? 20 : txVector.GetChannelWidth ()); //This is the PHY header
+        }
+      else
+        {
+          phyRate = mode.GetPhyRate (txVector, staId);
+        }
       if (mode.GetConstellationSize () == 2)
         {
           if (mode.GetCodeRate () == WIFI_CODE_RATE_1_2)
@@ -195,7 +204,7 @@
               return GetFecBpskBer (snr,
                                     nbits,
                                     txVector.GetChannelWidth () * 1000000, //signal spread
-                                    mode.GetPhyRate (txVector), //PHY rate
+                                    phyRate, //PHY rate
                                     10, //dFree
                                     11); //adFree
             }
@@ -204,7 +213,7 @@
               return GetFecBpskBer (snr,
                                     nbits,
                                     txVector.GetChannelWidth () * 1000000, //signal spread
-                                    mode.GetPhyRate (txVector), //PHY rate
+                                    phyRate, //PHY rate
                                     5, //dFree
                                     8); //adFree
             }
@@ -216,7 +225,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //PHY rate
+                                   phyRate, //PHY rate
                                    4, //m
                                    10, //dFree
                                    11, //adFree
@@ -227,7 +236,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //PHY rate
+                                   phyRate, //PHY rate
                                    4, //m
                                    5, //dFree
                                    8, //adFree
@@ -241,7 +250,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //PHY rate
+                                   phyRate, //PHY rate
                                    16, //m
                                    10, //dFree
                                    11, //adFree
@@ -252,7 +261,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //PHY rate
+                                   phyRate, //PHY rate
                                    16, //m
                                    5, //dFree
                                    8, //adFree
@@ -266,7 +275,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //PHY rate
+                                   phyRate, //PHY rate
                                    64, //m
                                    6, //dFree
                                    1, //adFree
@@ -278,7 +287,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //PHY rate
+                                   phyRate, //PHY rate
                                    64, //m
                                    4, //dFree
                                    14, //adFree
@@ -289,7 +298,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //PHY rate
+                                   phyRate, //PHY rate
                                    64, //m
                                    5, //dFree
                                    8, //adFree
@@ -303,7 +312,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, // signal spread
-                                   mode.GetPhyRate (txVector), //PHY rate
+                                   phyRate, //PHY rate
                                    256, // m
                                    4,  // dFree
                                    14,  // adFree
@@ -315,7 +324,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, // signal spread
-                                   mode.GetPhyRate (txVector), //PHY rate
+                                   phyRate, //PHY rate
                                    256, // m
                                    5,  // dFree
                                    8,  // adFree
@@ -330,7 +339,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, // signal spread
-                                   mode.GetPhyRate (txVector), //PHY rate
+                                   phyRate, //PHY rate
                                    1024, // m
                                    4,  // dFree
                                    14,  // adFree
@@ -342,7 +351,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, // signal spread
-                                   mode.GetPhyRate (txVector), //PHY rate
+                                   phyRate, //PHY rate
                                    1024, // m
                                    5,  // dFree
                                    8,  // adFree
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/yans-error-rate-model.h ns-3.34/src/wifi/model/yans-error-rate-model.h
--- ns-3.33/src/wifi/model/yans-error-rate-model.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/yans-error-rate-model.h	2021-07-14 10:31:07.000000000 -0700
@@ -63,8 +63,8 @@
 
 
 private:
-  //Inherited from ErrorRateModel
-  double DoGetChunkSuccessRate (WifiMode mode, WifiTxVector txVector, double snr, uint64_t nbits) const;
+  double DoGetChunkSuccessRate (WifiMode mode, const WifiTxVector& txVector, double snr, uint64_t nbits,
+                                uint8_t numRxAntennas, WifiPpduField field, uint16_t staId) const override;
   /**
    * Return BER of BPSK with the given parameters.
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/yans-wifi-channel.cc ns-3.34/src/wifi/model/yans-wifi-channel.cc
--- ns-3.33/src/wifi/model/yans-wifi-channel.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/yans-wifi-channel.cc	2021-07-14 10:31:07.000000000 -0700
@@ -103,7 +103,7 @@
           double rxPowerDbm = m_loss->CalcRxPower (txPowerDbm, senderMobility, receiverMobility);
           NS_LOG_DEBUG ("propagation: txPower=" << txPowerDbm << "dbm, rxPower=" << rxPowerDbm << "dbm, " <<
                         "distance=" << senderMobility->GetDistanceFrom (receiverMobility) << "m, delay=" << delay);
-          Ptr<WifiPpdu> copy = Copy (ppdu);
+          Ptr<WifiPpdu> copy = ppdu->Copy ();
           Ptr<NetDevice> dstNetDevice = (*i)->GetDevice ();
           uint32_t dstNode;
           if (dstNetDevice == 0)
@@ -135,7 +135,7 @@
     }
   RxPowerWattPerChannelBand rxPowerW;
   rxPowerW.insert ({std::make_pair (0, 0), (DbmToW (rxPowerDbm + phy->GetRxGain ()))}); //dummy band for YANS
-  phy->StartReceivePreamble (ppdu, rxPowerW);
+  phy->StartReceivePreamble (ppdu, rxPowerW, ppdu->GetTxDuration ());
 }
 
 std::size_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/yans-wifi-channel.h ns-3.34/src/wifi/model/yans-wifi-channel.h
--- ns-3.33/src/wifi/model/yans-wifi-channel.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/yans-wifi-channel.h	2021-07-14 10:31:07.000000000 -0700
@@ -54,9 +54,8 @@
   YansWifiChannel ();
   virtual ~YansWifiChannel ();
 
-  //inherited from Channel.
-  virtual std::size_t GetNDevices (void) const;
-  virtual Ptr<NetDevice> GetDevice (std::size_t i) const;
+  std::size_t GetNDevices (void) const override;
+  Ptr<NetDevice> GetDevice (std::size_t i) const override;
 
   /**
    * Adds the given YansWifiPhy to the PHY list
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/yans-wifi-phy.cc ns-3.34/src/wifi/model/yans-wifi-phy.cc
--- ns-3.33/src/wifi/model/yans-wifi-phy.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/yans-wifi-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -23,7 +23,6 @@
 #include "ns3/log.h"
 #include "yans-wifi-phy.h"
 #include "yans-wifi-channel.h"
-#include "wifi-ppdu.h"
 
 namespace ns3 {
 
@@ -83,9 +82,22 @@
 YansWifiPhy::StartTx (Ptr<WifiPpdu> ppdu)
 {
   NS_LOG_FUNCTION (this << ppdu);
-  WifiTxVector txVector = ppdu->GetTxVector ();
-  NS_LOG_DEBUG ("Start transmission: signal power before antenna gain=" << GetPowerDbm (txVector.GetTxPowerLevel ()) << "dBm");
-  m_channel->Send (this, ppdu, GetTxPowerForTransmission (txVector) + GetTxGain ());
+  NS_LOG_DEBUG ("Start transmission: signal power before antenna gain=" << GetPowerDbm (ppdu->GetTxVector ().GetTxPowerLevel ()) << "dBm");
+  m_channel->Send (this, ppdu, GetTxPowerForTransmission (ppdu) + GetTxGain ());
+}
+
+uint16_t
+YansWifiPhy::GetGuardBandwidth (uint16_t currentChannelWidth) const
+{
+  NS_ABORT_MSG ("Guard bandwidth not relevant for Yans");
+  return 0;
+}
+
+std::tuple<double, double, double>
+YansWifiPhy::GetTxMaskRejectionParams (void) const
+{
+  NS_ABORT_MSG ("Tx mask rejection params not relevant for Yans");
+  return std::make_tuple (0.0, 0.0, 0.0);
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/yans-wifi-phy.h ns-3.34/src/wifi/model/yans-wifi-phy.h
--- ns-3.33/src/wifi/model/yans-wifi-phy.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/yans-wifi-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -28,7 +28,6 @@
 namespace ns3 {
 
 class YansWifiChannel;
-class WifiPpdu;
 
 /**
  * \brief 802.11 PHY layer model
@@ -58,8 +57,10 @@
   virtual ~YansWifiPhy ();
 
   // Implementation of pure virtual method.
-  void StartTx (Ptr<WifiPpdu> ppdu);
-  virtual Ptr<Channel> GetChannel (void) const;
+  void StartTx (Ptr<WifiPpdu> ppdu) override;
+  Ptr<Channel> GetChannel (void) const override;
+  uint16_t GetGuardBandwidth (uint16_t currentChannelWidth) const override;
+  std::tuple<double, double, double> GetTxMaskRejectionParams (void) const override;
 
   /**
    * Set the YansWifiChannel this YansWifiPhy is to be connected to.
@@ -69,8 +70,7 @@
   void SetChannel (const Ptr<YansWifiChannel> channel);
 
 protected:
-  // Inherited
-  virtual void DoDispose (void);
+  void DoDispose (void) override;
 
 
 private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/block-ack-test-suite.cc ns-3.34/src/wifi/test/block-ack-test-suite.cc
--- ns-3.33/src/wifi/test/block-ack-test-suite.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/test/block-ack-test-suite.cc	2021-07-14 10:31:07.000000000 -0700
@@ -33,6 +33,9 @@
 #include "ns3/packet-socket-helper.h"
 #include "ns3/config.h"
 #include "ns3/pointer.h"
+#include "ns3/recipient-block-ack-agreement.h"
+#include "ns3/mac-rx-middle.h"
+#include <list>
 
 using namespace ns3;
 
@@ -79,7 +82,7 @@
   PacketBufferingCaseA ();
   virtual ~PacketBufferingCaseA ();
 private:
-  virtual void DoRun (void);
+  void DoRun (void) override;
   std::list<uint16_t> m_expectedBuffer; ///< expected test buffer
 };
 
@@ -176,7 +179,7 @@
   PacketBufferingCaseB ();
   virtual ~PacketBufferingCaseB ();
 private:
-  virtual void DoRun (void);
+  void DoRun (void) override;
   std::list<uint16_t> m_expectedBuffer; ///< expected test buffer
 };
 
@@ -262,7 +265,7 @@
 public:
   OriginatorBlockAckWindowTest ();
 private:
-  virtual void DoRun ();
+  void DoRun (void) override;
 };
 
 OriginatorBlockAckWindowTest::OriginatorBlockAckWindowTest ()
@@ -557,7 +560,7 @@
 public:
   CtrlBAckResponseHeaderTest ();
 private:
-  virtual void DoRun ();
+  void DoRun (void) override;
   CtrlBAckResponseHeader m_blockAckHdr; ///< block ack header
 };
 
@@ -569,7 +572,7 @@
 void
 CtrlBAckResponseHeaderTest::DoRun (void)
 {
-  m_blockAckHdr.SetType (COMPRESSED_BLOCK_ACK);
+  m_blockAckHdr.SetType (BlockAckType::COMPRESSED);
 
   //Case 1: startSeq < endSeq
   //          179        242
@@ -582,9 +585,23 @@
     {
       m_blockAckHdr.SetReceivedPacket (i);
     }
-  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetCompressedBitmap (), 0xffffc1ffffffffffLL, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[0], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[1], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[2], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[3], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[4], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[5], 0xc1, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[6], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[7], 0xff, "error in compressed bitmap");
   m_blockAckHdr.SetReceivedPacket (1500);
-  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetCompressedBitmap (), 0xffffc1ffffffffffLL, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[0], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[1], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[2], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[3], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[4], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[5], 0xc1, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[6], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[7], 0xff, "error in compressed bitmap");
   NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.IsPacketReceived (220), false, "error in compressed bitmap");
   NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.IsPacketReceived (225), true, "error in compressed bitmap");
   NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.IsPacketReceived (1500), false, "error in compressed bitmap");
@@ -602,9 +619,23 @@
     {
       m_blockAckHdr.SetReceivedPacket (i);
     }
-  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetCompressedBitmap (), 0x00000000007000ffffLL, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[0], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[1], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[2], 0x00, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[3], 0x70, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[4], 0x00, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[5], 0x00, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[6], 0x00, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[7], 0x00, "error in compressed bitmap");
   m_blockAckHdr.SetReceivedPacket (80);
-  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetCompressedBitmap (), 0x00000000007000ffffLL, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[0], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[1], 0xff, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[2], 0x00, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[3], 0x70, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[4], 0x00, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[5], 0x00, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[6], 0x00, "error in compressed bitmap");
+  NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.GetBitmap ()[7], 0x00, "error in compressed bitmap");
   NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.IsPacketReceived (4090), true, "error in compressed bitmap");
   NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.IsPacketReceived (4095), true, "error in compressed bitmap");
   NS_TEST_EXPECT_MSG_EQ (m_blockAckHdr.IsPacketReceived (10), false, "error in compressed bitmap");
